VendorSearch = LibStub("AceAddon-3.0"):NewAddon("VendorSearch", "AceConsole-3.0", "AceEvent-3.0")

KeywordType="name"
money=GetMoney();
VendorSearch.OpacityHiding = true
VendorSearch.FullHiding = false
VendorSearch.HidePriceFilter = false
VendorSearch.HideNonUsable = false
VendorSearch.Version=1.7

local options = {
    name = "VendorSearch",
    handler = VendorSearch,
    type = "group",
    args = {

 	    about = {
		     type = "group",
		     name = "About",
		     args = {
		     		about = {
		     			type = "description",
		     			name = "Made by Adriweb, 2009.   Please Donate if you enjoy it :D",
		 			},
		 	},
		},
 	    help = {
		     type = "group",
		     name = "Help",
		     args = {
		     		help = {
		     			type = "description",
		     			name = "By default, the addon is set with these settings : \n     Graphical Mode \n     Opacity Hiding Mode \n     Type of search : by Name \n     Other filters disabled (non-usable / too expensive items) \n\nYou can change these settings either in the Options Tab. \n \n After that, just type in your keywords in the second text box.",
		 			},
		 	},
		},
		Options = {
	     	type = "group",
	     	name = "Options",
    	 	desc = "Configure VendorSearch",
			args = {
     			Verbose = {
	     			type = "toggle",
	     			name = "Verbose/Textual mode",
    	 			desc = "Toggle the Textual mode",
					set = "ToggleVerbose",
					get = "IsVerbose",
     			},
     			OpacityHiding = {
	     			type = "toggle",
	     			name = "Opacity Hiding mode",
    	 			desc = "Toggle the hiding mode to opacity mode",
					set = "ToggleOpacityHiding",
					get = "IsOpacityHiding",
     			},
     			FullHiding = {
	     			type = "toggle",
	     			name = "Full Hiding mode",
    	 			desc = "Toggle the hiding mode to Full Hiding mode",
					set = "ToggleFullHiding",
					get = "IsFullHiding",
     			},
     			HideNonUsable = {
	     			type = "toggle",
	     			name = "Hide nonusable items",
    	 			desc = "Automatically hides the items you can't wear/use",
					set = "ToggleHideNonUsable",
					get = "IsHideNonUsable",
				},
				HideNonBuyable = {
	     			type = "toggle",
	     			name = "Hide nonbuyable items",
    	 			desc = "Automatically hides the items you can't afford.",
					set = "ToggleHidePriceFilter",
					get = "IsHidePriceFilter",
				},
     		},
     	},
	},
}


function VendorSearch:OnInitialize()
	LibStub("AceConfig-3.0"):RegisterOptionsTable("VendorSearch", options)
    self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("VendorSearch", "VendorSearch")
    self:RegisterChatCommand("vendorsearch", "ChatCommand")
 	self:RegisterChatCommand("vs", "ChatCommand")
end

function VendorSearch:OnEnable()
    -- Called when the addon is enabled
    DEFAULT_CHAT_FRAME:AddMessage("VendorSearch v1.7 : Loaded")
    self:RegisterEvent("MERCHANT_SHOW")
    self:RegisterEvent("MERCHANT_UPDATE")
end


function VendorSearch:OnDisable()
    -- Called when the addon is disabled
end

totalitems = GetMerchantNumItems();


--------------
--SearchBox:--
--------------

-- local searchboxtype = CreateFrame("EditBox","MerchantFrameSearchTypeFrame",MerchantFrame,"InputBoxTemplate")
-- searchboxtype:SetFrameStrata("HIGH")
-- searchboxtype:SetAutoFocus(nil)
-- searchboxtype:SetWidth(80)
-- searchboxtype:SetHeight(26)
-- searchboxtype:SetPoint("TOP",-65,-45)
-- searchboxtype:SetText("name")
-- searchboxtype:SetScript("OnEnterPressed", function(self)
-- 	KeywordType = searchboxtype:GetText()
-- searchboxtype:ClearFocus()
-- VendorSearch:Search(Keyword)
-- end)


local searchbox = CreateFrame("EditBox","MerchantFrameSearchFrame",MerchantFrame,"InputBoxTemplate")
searchbox:SetFrameStrata("HIGH")
searchbox:SetAutoFocus(nil)
searchbox:SetWidth(160)
searchbox:SetHeight(26)
searchbox:SetPoint("TOP",60,-45) -- next version : 60 and -45
searchbox:SetText("")
searchbox:SetScript("OnEnterPressed", function(self)
	Keyword = searchbox:GetText()
	searchbox:ClearFocus()
	VendorSearch:Search(Keyword)
	end)
searchbox:SetScript("OnTextChanged", function(self)
Keyword = searchbox:GetText()
VendorSearch:Search(Keyword)
end)


--------------
--Functions:--
--------------

function update()
    NewCurrPage = MerchantFrame.page
    TotalPages = math.ceil(GetMerchantNumItems() / MERCHANT_ITEMS_PER_PAGE)
    if self.Verbose == true then
    DEFAULT_CHAT_FRAME:AddMessage("Page: " .. NewCurrPage .. " Total Pages: " .. TotalPages);
    end
if CurrPage then
end
		Keyword = searchbox:GetText()
	if CurrPage and not (NewCurrPage == CurrPage) then
if self.Verbose == true then
DEFAULT_CHAT_FRAME:AddMessage("Going to Search - numbers above = different");
end
		VendorSearch:Search(Keyword)
	end
end
hooksecurefunc("MerchantFrame_Update", update);


function VendorSearch:IsVerbose(info)
    return self.Verbose
end

function VendorSearch:ToggleVerbose(info, value)
    self.Verbose = value
end

function VendorSearch:IsOpacityHiding(info)
    return VendorSearch.OpacityHiding
end

function VendorSearch:ToggleOpacityHiding(info, value)
    VendorSearch.OpacityHiding = value
    VendorSearch.FullHiding = not value
end

function VendorSearch:IsFullHiding(info)
    return VendorSearch.FullHiding
end

function VendorSearch:ToggleFullHiding(info, value)
    VendorSearch.FullHiding = value
    VendorSearch.OpacityHiding = not value
end

function VendorSearch:IsHidePriceFilter(info)
    return VendorSearch.HidePriceFilter
end

function VendorSearch:ToggleHidePriceFilter(info, value)
    VendorSearch.HidePriceFilter = value
end

function VendorSearch:IsHideNonUsable(info)
    return VendorSearch.HideNonUsable
end

function VendorSearch:ToggleHideNonUsable(info, value)
    VendorSearch.HideNonUsable = value
end


function VendorSearch:MERCHANT_SHOW()
 VendorSearch:MERCHANT_LIST()
	for i=1,totalitems do
		name, texture, price, quantity, numAvailable, isUsable, extendedCost = GetMerchantItemInfo(i);
		link = GetMerchantItemLink(i);
		itemname = name
	f = getglobal("MerchantItem" .. i)
	VendorSearch:Filter();
		if self.Verbose == true then
 			DEFAULT_CHAT_FRAME:AddMessage("Item " .. i .. " : " .. link .. " - " .. price .. " copper");
		end
 	end
	if Keyword then
		VendorSearch:Search(Keyword)
	end
end


function VendorSearch:Filter()
		if VendorSearch.HidePriceFilter == true then
			if price > money then
				f:SetAlpha(0.5);
			end
		end
		if VendorSearch.HideNonUsable == true then
			if not isUsable then
				f:SetAlpha(0.5);
			end
		end
end

function VendorSearch:Search(Keyword)
-- UIErrorsFrame:UnregisterEvent("UI_ERROR_MESSAGE");
found = 0
links = ""

CurrPage = MerchantFrame.page
if self.Verbose == true then
DEFAULT_CHAT_FRAME:AddMessage("CurrPage= " .. CurrPage)
end

CurrPage = MerchantFrame.page
searchstart=((10 * CurrPage) - 10 + 1)
maxsearch=12
i=1
 while GetMerchantItemInfo(i) and i <= searchstart + 9 do
 CurrPage = MerchantFrame.page
 	name, texture, price, quantity, numAvailable, isUsable, extendedCost = GetMerchantItemInfo(i);
	   link = GetMerchantItemLink(i);
 	   itemname = name
 	   itemprice = price
 	   ipart = math.floor((i / 10))
 	   if (i / 10) == ipart then
 	   itempage = (i / 10)
 	   newitemid = i - (10 * ipart) + 1
 	   	if i == 10 then
 	   	newitemid = 10
 	   	end
 	   else
 	   itempage = 1 + ipart
 	   newitemid = i - (10 * ipart)
 	   end
 	f = getglobal("MerchantItem" .. newitemid)
if self.Verbose == true then
DEFAULT_CHAT_FRAME:AddMessage(name .. " = " .. newitemid)
end
 if Keyword then
 	if KeywordType == "name" and string.find(strlower(name), strlower(Keyword)) then
if self.Verbose == true then
DEFAULT_CHAT_FRAME:AddMessage(name .. " is a result")
end
 		montrer();
 		 		VendorSearch:Filter();
  				found = found + 1
 				if links == "" then
 					links = links .. link .. " - " .. price .. "c"
 				else
 					links = links .. " , \n" .. link .. " - " .. price .. "c"
 				end
 				if i == totalitems then
					if self.Verbose == true then
						DEFAULT_CHAT_FRAME:AddMessage(" ")
						DEFAULT_CHAT_FRAME:AddMessage("Results of search : Item(s) found from keyword \"" .. Keyword .. "\" : " .. found)
						DEFAULT_CHAT_FRAME:AddMessage(links)
						DEFAULT_CHAT_FRAME:AddMessage(" ")
					end
				end
 	else
 		cacher();
	end
 end -- if keyword
i=(i + 1)
end --for
-- UIErrorsFrame:RegisterEvent("UI_ERROR_MESSAGE");
end --function




function cacher()
	if VendorSearch.FullHiding == true then
	    f:Hide();
	else
		f:SetAlpha(0.15);
	end
end

function montrer()
	f:Show();
	f:SetAlpha(1);
end

function VendorSearch:MERCHANT_LIST()
totalitems = GetMerchantNumItems();
	if self.Verbose == true then
		DEFAULT_CHAT_FRAME:AddMessage("Number of items : " .. totalitems);
	end
end


--------------
--Ace Stuff:--
--------------


function VendorSearch:ChatCommand(input)
   if (not input or input:trim() == "") then
        --InterfaceOptionsFrame_OpenToFrame(self.optionsFrame)
        LibStub("AceConfigDialog-3.0"):Open("VendorSearch")
    else
        LibStub("AceConfigCmd-3.0").HandleCommand(VendorSearch, "vs", "VendorSearch", input)
    end
end

function VendorSearch:ShowOptions()
    LibStub("AceConfigDialog-3.0"):Open("VendorSearch")
end